<!-- START doctoc generated TOC please keep comment here to allow auto update -->
<!-- DON'T EDIT THIS SECTION, INSTEAD RE-RUN doctoc TO UPDATE -->
目录
=================

- [概述](#%E6%A6%82%E8%BF%B0)
- [密钥对的生成和处理](#%E5%AF%86%E9%92%A5%E5%AF%B9%E7%9A%84%E7%94%9F%E6%88%90%E5%92%8C%E5%A4%84%E7%90%86)
  - [生成私钥](#%E7%94%9F%E6%88%90%E7%A7%81%E9%92%A5)
  - [从私钥生成公钥](#%E4%BB%8E%E7%A7%81%E9%92%A5%E7%94%9F%E6%88%90%E5%85%AC%E9%92%A5)

<!-- END doctoc generated TOC please keep comment here to allow auto update -->

# 概述
本文主要介绍用于数字签名的密钥对。文中将使用 OpenSSL 对密钥进行操作。

验证服务器会对以下请求的响应中的角色属性进行[数字签名](Yggdrasil-服务端技术规范#角色信息的序列化)：
 * [服务端验证客户端](Yggdrasil-服务端技术规范#服务端验证客户端)
 * [查询角色属性](Yggdrasil-服务端技术规范#查询角色属性)（仅当 `unsigned=false` 时才需要）

验证服务器通过[API 元数据](Yggdrasil-服务端技术规范#api-元数据获取)将公钥公开，以便 authlib-injector 获取。

注意：验证服务器应避免密钥的变化。如果使用多个服务端实例进行负载均衡，那么它们应该使用同一个密钥。

# 密钥对的生成和处理
下面对 OpenSSL 的调用都是使用标准输入和标准输出进行输入输出的。
如果要使用文件，可使用参数 `-in <file>` 和 `-out <file>`。

## 生成私钥
密钥算法为 RSA，推荐长度为 4096 位。

```
openssl genrsa 4096
```

生成的私钥将输出到标准输出。

## 从私钥生成公钥
```
openssl rsa -pubout
```

私钥从标准输入读入，公钥将输出到标准输出。

